<?php


namespace MirfalahTech\Laravel\Payment\Contracts;


use Illuminate\Contracts\Config\Repository;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;

interface PaymentGatewayDriver
{
    public function __construct(Repository $config,  array $options);

    public function createPaymentURL(PayableEntity $payable, array $options = []): string;

    public function verifyGatewayReturn(Request $request): bool;

    public function verifyGatewayCallback(Request $request, Response &$response = null): bool;

    public function getBillIdFromRequest(Request $request): ?string;

    public function getBillStatus(Request $request): ?int;

    public function isBillSuccess(Request $request): ?bool;

    public function isBillFailed(Request $request): ?bool;

    public function isBillPending(Request $request): ?bool;

    public function isPostMethodSupported(): bool;

    public function createPostMethodPayment(PayableEntity $payable, array $options = []): Response;
}
